#include <CtrlLib/CtrlLib.h>
#include "mbtray.h"
//#define IMAGECLASS Tray
//#define IMAGEFILE  <TrayIcon/tray.iml>
//#include <Draw/iml.h>

class TrayIcon : private Ctrl {
	
public:
	MBTrayApp* 		app;
	char* trayName;
	char*			trayImageFile;
	Callback        WhenLeftDown;
	Callback        WhenLeftUp;
	Callback        WhenLeftDouble;
	Callback1<Bar&> WhenBar;

	void            Show(bool b = true);
	void            Hide()                                 { Show(false); }
	void            Break()                                { EndLoop(0); }
	void            Run()                                  { EventLoop(this); }

	TrayIcon&  Icon(const Image &img);
	TrayIcon&  Tip(const char *text);

	typedef TrayIcon CLASSNAME;

	TrayIcon();
	~TrayIcon();
};

TrayIcon::TrayIcon()
{
    trayName= "Testing TrayIcon";        //only work when they are put here but why?????
	trayImageFile= "some_image.png";
    app = mb_tray_app_new_with_display ((unsigned char *) trayName, NULL, NULL,
				    (Display *)Xdisplay);
    Pixbuf = mb_pixbuf_new ((Display *)Xdisplay, Xscreenno);
    //XMapWindow(Xdisplay, w);
    AppImage = mb_pixbuf_img_new_from_file (Pixbuf, trayImageFile);
    //AppImage = mb_pixbuf_img_new_from_file (Pixbuf,"some_image.png" );
    //mb_tray_app_set_button_callback (app, button_callback );
    mb_tray_app_main (app);	//app is created here!!!!!
}

TrayIcon::~TrayIcon()
{
	
}



void TrayIcon::Show(bool b)
{
/*
	if(b == visible)
		return;
	if(visible)
		Notify(NIM_DELETE);
	visible = b;
	if(visible)
		Notify(NIM_ADD);
*/
}

TrayIcon& TrayIcon::Icon(const Image &img)
{
/*
	icon = img;
	Notify(NIM_MODIFY);
*/
	return *this;

}

TrayIcon& TrayIcon::Tip(const char *text)
{
/*
	tip = text;
	Notify(NIM_MODIFY);
*/
	return *this;

}

struct App : TrayIcon {
	void Info() {
//		Icon(Tray::Icon1());
		PromptOK("TrayIcon launched this prompt!");
//		Icon(Tray::Icon());
	}

	void Menu(Bar& bar) {
		bar.Add("Info..", THISBACK(Info));
		bar.Separator();
		bar.Add("Exit", THISBACK(Break));
	}

	typedef App CLASSNAME;

	App() {
	//	trayName= "Testing TrayIcon";        //can't be here but why?????
	//    trayImageFile= "some_image.png";
		WhenBar = THISBACK(Menu);
		WhenLeftDouble = THISBACK(Info);
		//Icon(Tray::Icon());
		Tip("This is U++ tray icon");
	}
};

GUI_APP_MAIN
{
	App().Run();
}
